Skip to main content
POST
/
exchange
Sub-account spot transfer
curl --request POST \
  --url https://api.hyperliquid.xyz/exchange \
  --header 'Content-Type: application/json' \
  --data '
{
  "action": {
    "type": "subAccountSpotTransfer",
    "subAccountUser": "0x1234567890abcdef1234567890abcdef12345678",
    "isDeposit": true,
    "token": "PURR",
    "amount": "100.0"
  },
  "nonce": 1705234567890,
  "signature": {
    "r": "0x0000000000000000000000000000000000000000000000000000000000000000",
    "s": "0x0000000000000000000000000000000000000000000000000000000000000000",
    "v": 27
  },
  "vaultAddress": null
}
'
import requests

url = "https://api.hyperliquid.xyz/exchange"

payload = {
"action": {
"type": "subAccountSpotTransfer",
"subAccountUser": "0x1234567890abcdef1234567890abcdef12345678",
"isDeposit": True,
"token": "PURR",
"amount": "100.0"
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": None
}
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
action: {
type: 'subAccountSpotTransfer',
subAccountUser: '0x1234567890abcdef1234567890abcdef12345678',
isDeposit: true,
token: 'PURR',
amount: '100.0'
},
nonce: 1705234567890,
signature: {
r: '0x0000000000000000000000000000000000000000000000000000000000000000',
s: '0x0000000000000000000000000000000000000000000000000000000000000000',
v: 27
},
vaultAddress: null
})
};

fetch('https://api.hyperliquid.xyz/exchange', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));


{
  "status": "<string>",
  "response": {}
}
You can only use this endpoint on the official Hyperliquid public API. It is not available through Chainstack, as the open-source node implementation does not support it yet. See Hyperliquid methods for the full availability breakdown.
This endpoint requires signature authentication. See our comprehensive Authentication via Signatures guide for implementation details.
Transfers spot tokens between the main account and a sub-account.
Get your own node endpoint todayStart for free and get your app to production levels immediately. No credit card required.You can sign up with your GitHub, X, Google, or Microsoft account.

Parameters

Required parameters

  • action (object, required) — The action object containing:
    • type (string) — Must be "subAccountSpotTransfer"
    • subAccountUser (string) — Sub-account address
    • isDeposit (boolean) — True to deposit into sub-account, false to withdraw
    • token (string) — Token to transfer
    • amount (string) — Amount to transfer
  • nonce (number, required) — Current timestamp in milliseconds (must be recent)
  • signature (object, required) — EIP-712 signature of the action

Optional parameters

  • vaultAddress (string, optional) — Address when trading on behalf of a vault or subaccount

Returns

Returns an object with the action status:
  • status"ok" if request processed
  • response — Contains action result data

Example request

curl -X POST https://api.hyperliquid.xyz/exchange \
  -H "Content-Type: application/json" \
  -d '{
    "action": {"type": "subAccountSpotTransfer"},
    "nonce": 1234567890123,
    "signature": {...}
  }'
from eth_account import Account
from hyperliquid.exchange import Exchange
from hyperliquid.utils import constants

# Wallet that signs the action
wallet = Account.from_key("YOUR_PRIVATE_KEY")

# Public Hyperliquid mainnet API (this method is not served by Chainstack)
exchange = Exchange(wallet, constants.MAINNET_API_URL)

# Deposit spot tokens from the main account into the sub-account
result = exchange.sub_account_spot_transfer(
    sub_account_user="0xSUB_ACCOUNT_ADDRESS",
    is_deposit=True,
    token="USDC:0xeb62eee3685fc4c43992febcd9e75443",
    amount=1,
)
print(result)
import { ExchangeClient, HttpTransport } from "@nktkas/hyperliquid";
import { privateKeyToAccount } from "viem/accounts";

// Wallet that signs the action
const wallet = privateKeyToAccount("YOUR_PRIVATE_KEY");

// Public Hyperliquid mainnet API (this method is not served by Chainstack)
const transport = new HttpTransport();
const exchange = new ExchangeClient({ transport, wallet });

// Deposit spot tokens from the main account into the sub-account
const result = await exchange.subAccountSpotTransfer({
  subAccountUser: "0xSUB_ACCOUNT_ADDRESS",
  isDeposit: true,
  token: "USDC:0xeb62eee3685fc4c43992febcd9e75443",
  amount: "1",
});
console.log(result);

Use case

  • Sub-account spot transfer — Transfers spot tokens between the main account and a sub-account.
Always ensure your system clock is synchronized. Nonce must be within a reasonable time window of the current server time or the request will be rejected.

Body

application/json
action
object
required
nonce
integer
required

Current timestamp in milliseconds

signature
object
required

EIP-712 signature of the action with r, s, v components

vaultAddress
string | null

Address when trading on behalf of a vault or subaccount (optional)

Response

200 - application/json

Action result

status
string

Request status

response
object

Action response data

Last modified on June 24, 2026